{ ppc386 -va -vh *.pas }
{ COMIENZO DE DESCRIPCION

Ejercicio tomado en el Examen Final del 27/9/01:
``Numeraci\'on de Cuthill-Mc Kee''.
Una red de computadoras tiene una serie de nodos
$a,b,c,...,n$ (ver figura) y se quiere conocer el
orden en el que se ir\'an infectando los nodos en
el caso de que uno de ellos se infecte con un virus.
Suponiendo que el primero en infectarse es el nodo $n$,
entonces \'este infectar\'a, en primera instancia, a los
nodos $g,k,j$ (primera 'capa de vecinos'), los cuales
est\'an conectados a \'el. Luego, estos nodos infectar\'an
a los nodos $h,c,b,l$ ('segunda capa'), estos a la tercera
capa $a,f,i,m$ y, finalmente, estos a la 4ta capa, la cual
consiste solamente del nodo $e$. Se tiene la informaci\'on
de la red en un vector de listas: vecinos: array [1..nnod]
of lista, y se pide escribir un procedimiento
INFECTA (vecinos, primero, orden) el cual, dado un nodo
`primero', retorna los nodos en una lista, segun el orden
en que se pueden ir infectando. Los nodos dentro de una
misma capa pueden aparecer en cualquier orden entre si.
keywords: algoritmos

FIN DE DESCRIPCION }

{-----+-----+-----+-----+-----+-----+-----+-----+-----+-----}
{ AL FINAL SE INCLUYEN DOS FIGURAS:
  EXTRAERLAS ANTES DE COMPILAR !!

Se propone el siguiente algoritmo (en seudo codigo).
Usar un arreglo `infectado' de tipo boolean que indica
si un nodo ha sido infectado o no y tener una cola
`contagio' que contiene aquellos nodos que han estado en
contacto con un nodo infectado y estan actualmente
contagiando a sus vecinos. 

El seudo codigo es el siguiente:

poner todo el arreglo `infectado' en `false';
poner `primero' en `contagio' y marcarlo como `infectado';

mientras que `contagio' no este vacia do begin
  sacar un elemento de `contagio';
  ponerlo en la lista `orden';
  poner todos sus vecinos que no esten infectados en `contagio' y
  marcarlos como infectados;
end;

SOLUCION: A continuacion se incluye el codigo (algunos
nombres estan cambiados, por ejemplo contagio -> procesar.
Al final se incluyen dos figuras en Postscript. }

{-----+-----+-----+-----+-----+-----+-----+-----+-----+-----}
{ $Id: ordena.pas v2 2002/04/05 15:30 mstorti Exp jdelia   $ }

program ordena;

uses u_listpi, u_colaai;

const
  nnod = 10;

var
  { Contiene el orden en que se recorren los nodos. }
  orden      : array [1..nnod] of integer;
  { Para cada nodo contiene la lista de vecinos. }
  vecinos    : array [1..nnod] of listpi;
  { Indica si el nodo fue puesto en la lista a procesar. }
  procesado  : array [1..nnod] of boolean;
  { Cola de elementos a procesar. }
  procesar   : colaai;
   
  k, n, m, o : integer;
  p	     : posicion;
  ii, jj     : integer ;

begin
{ Inicializa variables }
  for k:= 1 to nnod do begin
    orden [k] := 0;
    procesado [k]:= false;
    vecinos [k].anula;
{ Topologia tipo `anillo'}
     ii := (k mod nnod) + 1 ;
     jj := ( (nnod + k - 2) mod nnod) + 1;
     vecinos [k].inserta (ii, vecinos [k].primero);
     vecinos [k].inserta (jj, vecinos [k].primero);
   end ; {for}
   procesar.anula;

{  Carga el primer nodo }
   n := 1;
   procesar.pone (n);
   procesado [n] := true;
{ `o' contiene el orden del ultimo nodo entrado. }
   o := 0;
   while not (procesar.vacia) do begin
     o := o + 1;
   { Toma el siguiente nodo a procesar y le asigna el orden. }
     n := procesar.frente;
     procesar.quita;
     writeln ('visita ',n);
     orden [n] := o;
   { Recorre la lista de nodos conectados y los procesa }
     p := vecinos [n].primero;
     while p <> vecinos [n].fin do begin
       m := vecinos [n].recupera(p);
       if not procesado [m] then begin
	 procesar.pone (m);
	 procesado [m]:=true;
       end ; {if}
       p := vecinos [n].siguiente (p);
     end; {while}
   end; {while}
end.

{-----+-----+-----+-----+-----+-----+-----+-----+-----+-----}

{-----+-----+-----+---- cut here ---+-----+-----+-----+-----
%!PS-Adobe-2.0 EPSF-2.0
%%Title: ordena.eps
%%Creator: fig2dev Version 3.2 Patchlevel 3c
%%CreationDate: Thu Sep 27 12:00:58 2001
%%For: mstorti@minerva (Mario Storti, Guemes 3450; 3000-Santa Fe; Argentina, (54)-(42)-559175, (54)-(42)-550023)
%%BoundingBox: 0 0 234 208
%%Magnification: 1.0000
%%EndComments
/$F2psDict 200 dict def
$F2psDict begin
$F2psDict /mtrx matrix put
/col-1 {0 setgray} bind def
/col0 {0.000 0.000 0.000 srgb} bind def
/col1 {0.000 0.000 1.000 srgb} bind def
/col2 {0.000 1.000 0.000 srgb} bind def
/col3 {0.000 1.000 1.000 srgb} bind def
/col4 {1.000 0.000 0.000 srgb} bind def
/col5 {1.000 0.000 1.000 srgb} bind def
/col6 {1.000 1.000 0.000 srgb} bind def
/col7 {1.000 1.000 1.000 srgb} bind def
/col8 {0.000 0.000 0.560 srgb} bind def
/col9 {0.000 0.000 0.690 srgb} bind def
/col10 {0.000 0.000 0.820 srgb} bind def
/col11 {0.530 0.810 1.000 srgb} bind def
/col12 {0.000 0.560 0.000 srgb} bind def
/col13 {0.000 0.690 0.000 srgb} bind def
/col14 {0.000 0.820 0.000 srgb} bind def
/col15 {0.000 0.560 0.560 srgb} bind def
/col16 {0.000 0.690 0.690 srgb} bind def
/col17 {0.000 0.820 0.820 srgb} bind def
/col18 {0.560 0.000 0.000 srgb} bind def
/col19 {0.690 0.000 0.000 srgb} bind def
/col20 {0.820 0.000 0.000 srgb} bind def
/col21 {0.560 0.000 0.560 srgb} bind def
/col22 {0.690 0.000 0.690 srgb} bind def
/col23 {0.820 0.000 0.820 srgb} bind def
/col24 {0.500 0.190 0.000 srgb} bind def
/col25 {0.630 0.250 0.000 srgb} bind def
/col26 {0.750 0.380 0.000 srgb} bind def
/col27 {1.000 0.500 0.500 srgb} bind def
/col28 {1.000 0.630 0.630 srgb} bind def
/col29 {1.000 0.750 0.750 srgb} bind def
/col30 {1.000 0.880 0.880 srgb} bind def
/col31 {1.000 0.840 0.000 srgb} bind def

end
save
newpath 0 208 moveto 0 0 lineto 234 0 lineto 234 208 lineto closepath clip newpath
-121.0 279.0 translate
1 -1 scale

/cp {closepath} bind def
/ef {eofill} bind def
/gr {grestore} bind def
/gs {gsave} bind def
/sa {save} bind def
/rs {restore} bind def
/l {lineto} bind def
/m {moveto} bind def
/rm {rmoveto} bind def
/n {newpath} bind def
/s {stroke} bind def
/sh {show} bind def
/slc {setlinecap} bind def
/slj {setlinejoin} bind def
/slw {setlinewidth} bind def
/srgb {setrgbcolor} bind def
/rot {rotate} bind def
/sc {scale} bind def
/sd {setdash} bind def
/ff {findfont} bind def
/sf {setfont} bind def
/scf {scalefont} bind def
/sw {stringwidth} bind def
/tr {translate} bind def
/tnt {dup dup currentrgbcolor
  4 -2 roll dup 1 exch sub 3 -1 roll mul add
  4 -2 roll dup 1 exch sub 3 -1 roll mul add
  4 -2 roll dup 1 exch sub 3 -1 roll mul add srgb}
  bind def
/shd {dup dup currentrgbcolor 4 -2 roll mul 4 -2 roll mul
  4 -2 roll mul srgb} bind def
/$F2psBegin { $F2psDict begin /$F2psEnteredState save def} def
/$F2psEnd { $F2psEnteredState restore end} def

$F2psBegin
%%Page: 1 1
10 setmiterlimit
 0.06000 0.06000 sc
%
% Fig objects follow
%
% Polyline
7.500 slw
n 3300 1425 m
 2700 1725 l gs col0 s gr 
% Polyline
n 3495 1500 m
 3795 2325 l gs col0 s gr 
% Polyline
n 3690 2550 m
 3120 2775 l gs col0 s gr 
% Polyline
n 2670 2010 m
 2925 2655 l gs col0 s gr 
% Polyline
n 3660 1335 m
 4440 1470 l gs col0 s gr 
% Polyline
n 4620 1740 m
 4620 2310 l gs col0 s gr 
% Polyline
n 3975 2460 m
 4485 2490 l gs col0 s gr 
% Polyline
n 4875 2475 m
 5745 2520 l gs col0 s gr 
% Polyline
n 5745 2775 m
 5115 3150 l gs col0 s gr 
% Polyline
n 5066 3150 m 5074 3150 l gs col0 s gr
% Polyline
n 4665 2640 m
 4845 3150 l gs col0 s gr 
% Polyline
n 4725 3435 m
 3600 3735 l gs col0 s gr 
% Polyline
n 3600 3840 m
 4215 4185 l gs col0 s gr 
% Polyline
n 4440 4110 m
 4845 3540 l gs col0 s gr 
% Polyline
n 3555 3555 m
 3810 2670 l gs col0 s gr 
% Polyline
n 3015 2925 m
 3390 3645 l gs col0 s gr 
% Polyline
n 2265 3015 m
 2790 2820 l gs col0 s gr 
% Polyline
n 2100 3240 m
 2265 3810 l gs col0 s gr 
% Polyline
n 2430 3930 m
 3315 3795 l gs col0 s gr 
% Polyline
n 3360 3915 m
 3000 4455 l gs col0 s gr 
% Polyline
n 2981 4455 m 2989 4455 l gs col0 s gr
% Polyline
n 2775 4485 m
 2385 4065 l gs col0 s gr 
% Polyline
n 4725 1650 m
 5775 2475 l gs col0 s gr 
/Helvetica-BoldOblique ff 210.00 scf sf
2550 1875 m
gs 1 -1 sc (a) col0 sh gr
/Helvetica-BoldOblique ff 210.00 scf sf
3375 3825 m
gs 1 -1 sc (b) col0 sh gr
/Helvetica-BoldOblique ff 210.00 scf sf
3750 2550 m
gs 1 -1 sc (c) col0 sh gr
/Helvetica-BoldOblique ff 210.00 scf sf
2025 3150 m
gs 1 -1 sc (e) col0 sh gr
/Helvetica-BoldOblique ff 210.00 scf sf
2925 2850 m
gs 1 -1 sc (f) col0 sh gr
/Helvetica-BoldOblique ff 210.00 scf sf
4500 1575 m
gs 1 -1 sc (g) col0 sh gr
/Helvetica-BoldOblique ff 210.00 scf sf
3375 1350 m
gs 1 -1 sc (h) col0 sh gr
/Helvetica-BoldOblique ff 210.00 scf sf
2250 4050 m
gs 1 -1 sc (i) col0 sh gr
/Helvetica-BoldOblique ff 210.00 scf sf
4875 3375 m
gs 1 -1 sc (j) col0 sh gr
/Helvetica-BoldOblique ff 210.00 scf sf
4575 2550 m
gs 1 -1 sc (k) col0 sh gr
/Helvetica-BoldOblique ff 210.00 scf sf
4275 4350 m
gs 1 -1 sc (l) col0 sh gr
/Helvetica-BoldOblique ff 210.00 scf sf
2850 4650 m
gs 1 -1 sc (m) col0 sh gr
/Helvetica-BoldOblique ff 210.00 scf sf
5775 2625 m
gs 1 -1 sc (n) col0 sh gr
$F2psEnd
rs
{-----+-----+-----+---- cut here ---+-----+-----+-----+-----}

{-----+-----+-----+---- cut here ---+-----+-----+-----+-----}
%!PS-Adobe-2.0 EPSF-2.0
%%Title: ordena1.eps
%%Creator: fig2dev Version 3.2 Patchlevel 3c
%%CreationDate: Thu Sep 27 11:59:53 2001
%%For: mstorti@minerva (Mario Storti, Guemes 3450; 3000-Santa Fe; Argentina, (54)-(42)-559175, (54)-(42)-550023)
%%BoundingBox: 0 0 310 251
%%Magnification: 1.0000
%%EndComments
/$F2psDict 200 dict def
$F2psDict begin
$F2psDict /mtrx matrix put
/col-1 {0 setgray} bind def
/col0 {0.000 0.000 0.000 srgb} bind def
/col1 {0.000 0.000 1.000 srgb} bind def
/col2 {0.000 1.000 0.000 srgb} bind def
/col3 {0.000 1.000 1.000 srgb} bind def
/col4 {1.000 0.000 0.000 srgb} bind def
/col5 {1.000 0.000 1.000 srgb} bind def
/col6 {1.000 1.000 0.000 srgb} bind def
/col7 {1.000 1.000 1.000 srgb} bind def
/col8 {0.000 0.000 0.560 srgb} bind def
/col9 {0.000 0.000 0.690 srgb} bind def
/col10 {0.000 0.000 0.820 srgb} bind def
/col11 {0.530 0.810 1.000 srgb} bind def
/col12 {0.000 0.560 0.000 srgb} bind def
/col13 {0.000 0.690 0.000 srgb} bind def
/col14 {0.000 0.820 0.000 srgb} bind def
/col15 {0.000 0.560 0.560 srgb} bind def
/col16 {0.000 0.690 0.690 srgb} bind def
/col17 {0.000 0.820 0.820 srgb} bind def
/col18 {0.560 0.000 0.000 srgb} bind def
/col19 {0.690 0.000 0.000 srgb} bind def
/col20 {0.820 0.000 0.000 srgb} bind def
/col21 {0.560 0.000 0.560 srgb} bind def
/col22 {0.690 0.000 0.690 srgb} bind def
/col23 {0.820 0.000 0.820 srgb} bind def
/col24 {0.500 0.190 0.000 srgb} bind def
/col25 {0.630 0.250 0.000 srgb} bind def
/col26 {0.750 0.380 0.000 srgb} bind def
/col27 {1.000 0.500 0.500 srgb} bind def
/col28 {1.000 0.630 0.630 srgb} bind def
/col29 {1.000 0.750 0.750 srgb} bind def
/col30 {1.000 0.880 0.880 srgb} bind def
/col31 {1.000 0.840 0.000 srgb} bind def

end
save
newpath 0 251 moveto 0 0 lineto 310 0 lineto 310 251 lineto closepath clip newpath
-97.0 302.0 translate
1 -1 scale

/cp {closepath} bind def
/ef {eofill} bind def
/gr {grestore} bind def
/gs {gsave} bind def
/sa {save} bind def
/rs {restore} bind def
/l {lineto} bind def
/m {moveto} bind def
/rm {rmoveto} bind def
/n {newpath} bind def
/s {stroke} bind def
/sh {show} bind def
/slc {setlinecap} bind def
/slj {setlinejoin} bind def
/slw {setlinewidth} bind def
/srgb {setrgbcolor} bind def
/rot {rotate} bind def
/sc {scale} bind def
/sd {setdash} bind def
/ff {findfont} bind def
/sf {setfont} bind def
/scf {scalefont} bind def
/sw {stringwidth} bind def
/tr {translate} bind def
/tnt {dup dup currentrgbcolor
  4 -2 roll dup 1 exch sub 3 -1 roll mul add
  4 -2 roll dup 1 exch sub 3 -1 roll mul add
  4 -2 roll dup 1 exch sub 3 -1 roll mul add srgb}
  bind def
/shd {dup dup currentrgbcolor 4 -2 roll mul 4 -2 roll mul
  4 -2 roll mul srgb} bind def
 /DrawEllipse {
	/endangle exch def
	/startangle exch def
	/yrad exch def
	/xrad exch def
	/y exch def
	/x exch def
	/savematrix mtrx currentmatrix def
	x y tr xrad yrad sc 0 0 1 startangle endangle arc
	closepath
	savematrix setmatrix
	} def

/$F2psBegin { $F2psDict begin /$F2psEnteredState save def} def
/$F2psEnd { $F2psEnteredState restore end} def

$F2psBegin
%%Page: 1 1
10 setmiterlimit
 0.06000 0.06000 sc
%
% Fig objects follow
%
/Helvetica-Narrow-Oblique ff 210.00 scf sf
5829 2888 m
gs 1 -1 sc (1er nodo ) col0 sh gr
/Helvetica-Narrow-Oblique ff 210.00 scf sf
5854 3087 m
gs 1 -1 sc (infectado) col0 sh gr
7.500 slw
 [60] 0 sd
% Ellipse
n 2096 3095 246 246 0 360 DrawEllipse gs col0 s gr
 [] 0 sd
% Polyline
n 3300 1425 m
 2700 1725 l gs col0 s gr 
% Polyline
n 3495 1500 m
 3795 2325 l gs col0 s gr 
% Polyline
n 3690 2550 m
 3120 2775 l gs col0 s gr 
% Polyline
n 2670 2010 m
 2925 2655 l gs col0 s gr 
% Polyline
n 3660 1335 m
 4440 1470 l gs col0 s gr 
% Polyline
n 4620 1740 m
 4620 2310 l gs col0 s gr 
% Polyline
n 3975 2460 m
 4485 2490 l gs col0 s gr 
% Polyline
n 4875 2475 m
 5745 2520 l gs col0 s gr 
% Polyline
n 5745 2775 m
 5115 3150 l gs col0 s gr 
% Polyline
n 5066 3150 m 5074 3150 l gs col0 s gr
% Polyline
n 4665 2640 m
 4845 3150 l gs col0 s gr 
% Polyline
n 4725 3435 m
 3600 3735 l gs col0 s gr 
% Polyline
n 3600 3840 m
 4215 4185 l gs col0 s gr 
% Polyline
n 4440 4110 m
 4845 3540 l gs col0 s gr 
% Polyline
n 3555 3555 m
 3810 2670 l gs col0 s gr 
% Polyline
n 3015 2925 m
 3390 3645 l gs col0 s gr 
% Polyline
n 2265 3015 m
 2790 2820 l gs col0 s gr 
% Polyline
n 2100 3240 m
 2265 3810 l gs col0 s gr 
% Polyline
n 2430 3930 m
 3315 3795 l gs col0 s gr 
% Polyline
n 3360 3915 m
 3000 4455 l gs col0 s gr 
% Polyline
n 2981 4455 m 2989 4455 l gs col0 s gr
% Polyline
n 2775 4485 m
 2385 4065 l gs col0 s gr 
% Polyline
n 4800 1695 m
 5790 2400 l gs col0 s gr 
% Polyline
2 slj
 [60] 0 sd
n 4628 3441 m 4654 3484 l 4680 3522 l 4706 3556 l 4730 3586 l 4752 3611 l
 4773 3631 l 4792 3649 l 4808 3663 l 4824 3675 l 4838 3684 l
 4851 3692 l 4863 3699 l 4875 3704 l 4886 3709 l 4898 3714 l
 4910 3718 l 4924 3722 l 4938 3726 l 4953 3730 l 4970 3733 l
 4988 3735 l 5008 3736 l 5028 3736 l 5049 3733 l 5069 3726 l
 5088 3715 l 5104 3699 l 5118 3681 l 5129 3662 l 5137 3643 l
 5144 3626 l 5149 3612 l 5152 3600 l 5154 3591 l 5154 3584 l
 5154 3579 l 5154 3576 l 5153 3573 l 5151 3570 l 5149 3566 l
 5147 3561 l 5145 3553 l 5142 3541 l 5139 3523 l 5135 3500 l
 5131 3470 l 5127 3431 l 5122 3383 l 5115 3325 l 5108 3257 l
 5099 3179 l 5088 3092 l 5080 3032 l 5072 2971 l 5064 2909 l
 5055 2848 l 5047 2789 l 5039 2732 l 5031 2677 l 5024 2624 l
 5017 2575 l 5011 2529 l 5005 2485 l 5000 2444 l 4996 2406 l
 4991 2369 l 4987 2335 l 4984 2303 l 4980 2272 l 4977 2242 l
 4974 2212 l 4971 2184 l 4968 2155 l 4964 2126 l 4961 2097 l
 4957 2066 l 4952 2035 l 4948 2002 l 4942 1967 l 4936 1931 l
 4929 1892 l 4921 1852 l 4913 1809 l 4903 1764 l 4892 1717 l
 4880 1668 l 4868 1617 l 4854 1566 l 4839 1514 l 4823 1463 l
 4807 1413 l 4790 1366 l 4774 1325 l 4758 1288 l 4742 1254 l
 4726 1224 l 4712 1198 l 4698 1175 l 4684 1155 l 4672 1139 l
 4661 1124 l 4650 1112 l 4640 1103 l 4631 1095 l 4622 1088 l
 4615 1084 l 4607 1080 l 4601 1078 l 4595 1076 l 4589 1076 l
 4583 1076 l 4578 1077 l 4572 1078 l 4567 1080 l 4562 1082 l
 4557 1085 l 4551 1088 l 4545 1092 l 4539 1096 l 4533 1101 l
 4526 1106 l 4519 1112 l 4512 1118 l 4504 1126 l 4495 1134 l
 4486 1144 l 4477 1155 l 4467 1167 l 4457 1182 l 4447 1198 l
 4437 1217 l 4427 1238 l 4417 1261 l 4408 1288 l 4398 1325 l
 4390 1365 l 4382 1406 l 4377 1447 l 4372 1488 l 4368 1528 l
 4366 1565 l 4364 1601 l 4363 1634 l 4363 1665 l 4363 1694 l
 4363 1721 l 4364 1746 l 4365 1770 l 4367 1793 l 4369 1815 l
 4371 1837 l 4373 1859 l 4375 1883 l 4377 1907 l 4380 1933 l
 4382 1960 l 4385 1991 l 4388 2024 l 4391 2061 l 4394 2101 l
 4397 2145 l 4400 2193 l 4404 2245 l 4409 2300 l 4413 2359 l
 4418 2421 l 4424 2484 l 4430 2548 l 4438 2619 l 4446 2686 l
 4453 2748 l 4461 2804 l 4467 2854 l 4473 2897 l 4478 2934 l
 4482 2966 l 4485 2992 l 4487 3013 l 4489 3031 l 4490 3045 l
 4491 3057 l 4492 3067 l 4493 3077 l 4493 3086 l 4494 3095 l
 4496 3105 l 4498 3117 l 4502 3131 l 4506 3148 l 4512 3168 l
 4520 3191 l 4529 3218 l 4540 3249 l 4554 3283 l 4569 3321 l
 4587 3360 l 4607 3401 l
 cp gs col0 s gr  [] 0 sd
% Polyline
 [60] 0 sd
n 3215 3771 m 3239 3827 l 3267 3881 l 3297 3931 l 3328 3977 l 3360 4020 l
 3392 4058 l 3424 4092 l 3455 4122 l 3485 4148 l 3514 4171 l
 3541 4191 l 3568 4208 l 3594 4222 l 3619 4235 l 3643 4246 l
 3667 4255 l 3691 4264 l 3714 4272 l 3738 4279 l 3762 4287 l
 3786 4295 l 3812 4303 l 3838 4311 l 3866 4321 l 3895 4332 l
 3926 4344 l 3959 4357 l 3994 4371 l 4031 4387 l 4070 4403 l
 4110 4421 l 4152 4439 l 4195 4457 l 4238 4475 l 4281 4491 l
 4323 4505 l 4363 4516 l 4400 4525 l 4434 4531 l 4465 4534 l
 4493 4536 l 4518 4536 l 4541 4535 l 4561 4533 l 4578 4530 l
 4594 4526 l 4608 4521 l 4620 4516 l 4630 4511 l 4640 4506 l
 4648 4500 l 4656 4494 l 4663 4487 l 4669 4480 l 4675 4473 l
 4680 4466 l 4685 4458 l 4690 4450 l 4695 4441 l 4699 4432 l
 4704 4422 l 4708 4410 l 4711 4398 l 4714 4385 l 4716 4371 l
 4717 4355 l 4717 4338 l 4716 4319 l 4712 4299 l 4706 4278 l
 4696 4255 l 4684 4231 l 4666 4203 l 4643 4174 l 4618 4147 l
 4591 4121 l 4563 4098 l 4534 4077 l 4504 4058 l 4475 4043 l
 4446 4029 l 4417 4019 l 4388 4010 l 4360 4003 l 4333 3997 l
 4305 3992 l 4278 3988 l 4251 3985 l 4224 3981 l 4197 3976 l
 4170 3970 l 4142 3963 l 4114 3954 l 4085 3942 l 4056 3927 l
 4026 3909 l 3996 3887 l 3966 3861 l 3936 3830 l 3906 3796 l
 3878 3756 l 3851 3713 l 3827 3666 l 3807 3616 l 3791 3565 l
 3780 3514 l 3772 3466 l 3769 3421 l 3770 3380 l 3774 3343 l
 3781 3312 l 3791 3285 l 3802 3263 l 3816 3244 l 3831 3230 l
 3847 3218 l 3864 3209 l 3882 3202 l 3901 3196 l 3919 3191 l
 3938 3185 l 3957 3178 l 3975 3169 l 3994 3158 l 4011 3143 l
 4028 3125 l 4043 3102 l 4058 3073 l 4071 3038 l 4082 2997 l
 4091 2949 l 4098 2893 l 4103 2830 l 4104 2761 l 4103 2687 l
 4099 2608 l 4094 2543 l 4087 2479 l 4078 2415 l 4069 2353 l
 4060 2293 l 4050 2236 l 4040 2182 l 4029 2132 l 4019 2085 l
 4009 2041 l 3999 2000 l 3990 1962 l 3981 1928 l 3972 1895 l
 3963 1865 l 3955 1836 l 3946 1809 l 3938 1783 l 3930 1759 l
 3922 1734 l 3913 1710 l 3905 1686 l 3896 1661 l 3886 1636 l
 3876 1609 l 3866 1582 l 3855 1553 l 3843 1522 l 3830 1490 l
 3817 1455 l 3802 1419 l 3786 1381 l 3770 1341 l 3752 1300 l
 3733 1257 l 3713 1214 l 3692 1171 l 3670 1129 l 3648 1088 l
 3626 1051 l 3605 1019 l 3584 991 l 3564 966 l 3545 945 l
 3527 927 l 3509 912 l 3493 900 l 3478 890 l 3463 882 l
 3450 876 l 3438 872 l 3427 869 l 3416 867 l 3406 867 l
 3397 867 l 3389 869 l 3381 871 l 3373 874 l 3366 877 l
 3359 881 l 3353 885 l 3346 890 l 3340 895 l 3333 901 l
 3327 907 l 3320 914 l 3313 921 l 3306 929 l 3299 938 l
 3292 948 l 3284 959 l 3276 971 l 3269 984 l 3261 998 l
 3253 1015 l 3245 1033 l 3237 1053 l 3230 1075 l 3223 1099 l
 3217 1126 l 3212 1155 l 3209 1187 l 3207 1229 l 3207 1274 l
 3210 1319 l 3214 1363 l 3220 1405 l 3227 1445 l 3235 1482 l
 3245 1517 l 3255 1547 l 3266 1575 l 3277 1600 l 3289 1623 l
 3301 1644 l 3314 1662 l 3326 1680 l 3339 1697 l 3352 1713 l
 3365 1730 l 3377 1748 l 3390 1767 l 3403 1788 l 3415 1812 l
 3427 1839 l 3439 1870 l 3451 1904 l 3462 1944 l 3472 1988 l
 3482 2038 l 3491 2093 l 3499 2154 l 3505 2220 l 3510 2290 l
 3513 2363 l 3514 2439 l 3513 2511 l 3511 2581 l 3506 2648 l
 3500 2712 l 3492 2771 l 3482 2825 l 3471 2873 l 3459 2917 l
 3446 2956 l 3431 2990 l 3416 3020 l 3400 3045 l 3384 3068 l
 3367 3088 l 3350 3105 l 3332 3120 l 3315 3135 l 3298 3148 l
 3280 3162 l 3263 3176 l 3247 3190 l 3231 3207 l 3216 3225 l
 3202 3246 l 3190 3270 l 3178 3297 l 3169 3328 l 3162 3363 l
 3157 3402 l 3154 3445 l 3155 3492 l 3159 3544 l 3167 3598 l
 3179 3655 l 3195 3713 l
 cp gs col0 s gr  [] 0 sd
% Polyline
 [60] 0 sd
n 2780 2879 m 2768 2934 l 2753 2990 l 2735 3043 l 2716 3094 l 2696 3142 l
 2674 3186 l 2652 3227 l 2629 3264 l 2605 3296 l 2582 3326 l
 2558 3351 l 2534 3374 l 2510 3395 l 2487 3413 l 2463 3429 l
 2440 3444 l 2416 3457 l 2393 3471 l 2370 3484 l 2346 3498 l
 2323 3513 l 2300 3529 l 2278 3547 l 2255 3567 l 2233 3589 l
 2212 3615 l 2191 3643 l 2170 3676 l 2151 3711 l 2133 3751 l
 2117 3794 l 2103 3841 l 2091 3891 l 2083 3942 l 2077 3996 l
 2076 4049 l 2079 4104 l 2087 4157 l 2097 4206 l 2111 4251 l
 2126 4292 l 2142 4329 l 2160 4362 l 2178 4390 l 2196 4415 l
 2215 4436 l 2233 4455 l 2251 4471 l 2269 4484 l 2287 4496 l
 2305 4506 l 2323 4515 l 2341 4523 l 2359 4531 l 2378 4540 l
 2398 4548 l 2418 4557 l 2439 4567 l 2462 4578 l 2486 4591 l
 2511 4605 l 2538 4620 l 2567 4638 l 2598 4657 l 2630 4677 l
 2664 4698 l 2700 4720 l 2736 4742 l 2774 4764 l 2811 4783 l
 2853 4802 l 2892 4817 l 2930 4829 l 2965 4838 l 2997 4844 l
 3026 4849 l 3052 4852 l 3076 4853 l 3098 4853 l 3117 4853 l
 3135 4851 l 3152 4849 l 3167 4847 l 3181 4844 l 3195 4840 l
 3208 4836 l 3221 4832 l 3234 4827 l 3246 4821 l 3259 4814 l
 3272 4807 l 3284 4798 l 3296 4789 l 3308 4777 l 3319 4764 l
 3329 4749 l 3337 4732 l 3342 4712 l 3343 4690 l 3340 4665 l
 3332 4638 l 3319 4610 l 3302 4583 l 3283 4557 l 3261 4532 l
 3237 4510 l 3212 4491 l 3186 4474 l 3160 4460 l 3133 4447 l
 3106 4437 l 3079 4428 l 3052 4420 l 3025 4413 l 2998 4405 l
 2971 4398 l 2943 4390 l 2916 4381 l 2889 4369 l 2862 4356 l
 2835 4339 l 2808 4320 l 2781 4296 l 2755 4268 l 2731 4235 l
 2708 4198 l 2687 4155 l 2668 4109 l 2654 4058 l 2643 4005 l
 2638 3954 l 2636 3903 l 2638 3855 l 2644 3809 l 2651 3766 l
 2661 3728 l 2673 3693 l 2685 3663 l 2699 3636 l 2714 3613 l
 2729 3592 l 2745 3575 l 2761 3559 l 2777 3545 l 2794 3532 l
 2811 3519 l 2828 3507 l 2845 3494 l 2863 3480 l 2881 3464 l
 2898 3447 l 2917 3427 l 2935 3404 l 2954 3377 l 2973 3347 l
 2991 3313 l 3010 3275 l 3029 3233 l 3047 3188 l 3065 3140 l
 3082 3091 l 3097 3041 l 3115 2977 l 3130 2918 l 3142 2867 l
 3151 2824 l 3158 2790 l 3163 2764 l 3167 2746 l 3169 2734 l
 3171 2727 l 3171 2724 l 3171 2723 l 3171 2724 l 3170 2725 l
 3169 2725 l 3167 2722 l 3165 2716 l 3162 2704 l 3159 2687 l
 3154 2662 l 3149 2629 l 3142 2589 l 3133 2540 l 3122 2484 l
 3109 2424 l 3097 2374 l 3083 2325 l 3070 2278 l 3056 2233 l
 3043 2192 l 3030 2155 l 3019 2121 l 3008 2090 l 2998 2063 l
 2988 2039 l 2980 2018 l 2972 1998 l 2964 1981 l 2957 1964 l
 2950 1948 l 2942 1932 l 2935 1916 l 2927 1899 l 2918 1881 l
 2909 1861 l 2898 1840 l 2886 1816 l 2874 1790 l 2859 1761 l
 2843 1730 l 2826 1697 l 2808 1663 l 2788 1627 l 2768 1592 l
 2748 1559 l 2731 1532 l 2714 1508 l 2698 1487 l 2684 1468 l
 2671 1453 l 2659 1439 l 2649 1428 l 2640 1419 l 2632 1411 l
 2625 1405 l 2620 1400 l 2615 1397 l 2611 1394 l 2608 1393 l
 2605 1391 l 2602 1391 l 2600 1391 l 2598 1391 l 2596 1391 l
 2593 1392 l 2590 1393 l 2587 1395 l 2584 1396 l 2580 1398 l
 2575 1401 l 2569 1404 l 2563 1407 l 2556 1412 l 2549 1417 l
 2541 1423 l 2532 1431 l 2523 1441 l 2515 1452 l 2506 1466 l
 2495 1489 l 2486 1514 l 2477 1540 l 2470 1565 l 2464 1587 l
 2459 1608 l 2455 1626 l 2452 1641 l 2448 1655 l 2445 1667 l
 2443 1678 l 2441 1689 l 2439 1700 l 2437 1713 l 2436 1727 l
 2435 1745 l 2435 1766 l 2436 1792 l 2437 1823 l 2440 1860 l
 2444 1903 l 2450 1951 l 2458 2005 l 2468 2063 l 2479 2114 l
 2491 2163 l 2504 2209 l 2518 2251 l 2533 2288 l 2549 2319 l
 2565 2345 l 2581 2366 l 2598 2383 l 2614 2395 l 2631 2405 l
 2647 2412 l 2663 2418 l 2680 2423 l 2695 2429 l 2711 2435 l
 2726 2444 l 2740 2455 l 2754 2470 l 2767 2490 l 2778 2516 l
 2787 2547 l 2794 2586 l 2799 2631 l 2800 2684 l 2798 2744 l
 2791 2809 l
 cp gs col0 s gr  [] 0 sd
/Helvetica-BoldOblique ff 210.00 scf sf
2550 1875 m
gs 1 -1 sc (a) col0 sh gr
/Helvetica-BoldOblique ff 210.00 scf sf
3375 3825 m
gs 1 -1 sc (b) col0 sh gr
/Helvetica-BoldOblique ff 210.00 scf sf
3750 2550 m
gs 1 -1 sc (c) col0 sh gr
/Helvetica-BoldOblique ff 210.00 scf sf
2025 3150 m
gs 1 -1 sc (e) col0 sh gr
/Helvetica-BoldOblique ff 210.00 scf sf
2925 2850 m
gs 1 -1 sc (f) col0 sh gr
/Helvetica-BoldOblique ff 210.00 scf sf
4500 1575 m
gs 1 -1 sc (g) col0 sh gr
/Helvetica-BoldOblique ff 210.00 scf sf
3375 1350 m
gs 1 -1 sc (h) col0 sh gr
/Helvetica-BoldOblique ff 210.00 scf sf
2250 4050 m
gs 1 -1 sc (i) col0 sh gr
/Helvetica-BoldOblique ff 210.00 scf sf
4875 3375 m
gs 1 -1 sc (j) col0 sh gr
/Helvetica-BoldOblique ff 210.00 scf sf
4575 2550 m
gs 1 -1 sc (k) col0 sh gr
/Helvetica-BoldOblique ff 210.00 scf sf
4275 4350 m
gs 1 -1 sc (l) col0 sh gr
/Helvetica-BoldOblique ff 210.00 scf sf
2850 4650 m
gs 1 -1 sc (m) col0 sh gr
/Helvetica-BoldOblique ff 210.00 scf sf
5775 2625 m
gs 1 -1 sc (n) col0 sh gr
/Helvetica-Narrow-Oblique ff 210.00 scf sf
5070 3859 m
gs 1 -1 sc (1ra capa) col0 sh gr
/Helvetica-Narrow-Oblique ff 210.00 scf sf
4597 4761 m
gs 1 -1 sc (2da capa) col0 sh gr
/Helvetica-Narrow-Oblique ff 210.00 scf sf
3084 4973 m
gs 1 -1 sc (3ra capa) col0 sh gr
/Helvetica-Narrow-Oblique ff 210.00 scf sf
1629 2756 m
gs 1 -1 sc (4ta capa) col0 sh gr
$F2psEnd
rs
-----+-----+-----+---- cut here ---+-----+-----+-----+-----}
